unit demmotcle;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Forms, Dialogs, Controls, StdCtrls, 
  Buttons, ExtCtrls;

type
  TFdemMotCle = class(TForm)
    Panel1: TPanel;
    ListeMots: TComboBox;
    Label1: TLabel;
    Panel2: TPanel;
    Label2: TLabel;
    Panel3: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Panel4: TPanel;
    SrcLabel: TLabel;
    DstLabel: TLabel;
    IncludeBtn: TSpeedButton;
    IncAllBtn: TSpeedButton;
    ExcludeBtn: TSpeedButton;
    ExAllBtn: TSpeedButton;
    SrcList: TListBox;
    DstList: TListBox;
    Button1: TButton;
    Label3: TLabel;
    Button2: TButton;
    Label4: TLabel;
    Button3: TButton;
    procedure IncludeBtnClick(Sender: TObject);
    procedure ExcludeBtnClick(Sender: TObject);
    procedure IncAllBtnClick(Sender: TObject);
    procedure ExcAllBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ListeMotsKeyPress(Sender: TObject; var Key: Char);
    procedure Button1Click(Sender: TObject);
    procedure ListeMotsChange(Sender: TObject);
    procedure ListeMotsDropDown(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    LesGroupes:TStringList;
    LesSequences:TStringList;
    procedure MoveSelected(List: TCustomListBox; Items: TStrings);
    procedure SetItem(List: TListBox; Index: Integer);
    function GetFirstSelection(List: TCustomListBox): Integer;
    procedure SetButtons;
    procedure AjusteListe(i:integer);
  end;

var
  FdemMotCle: TFdemMotCle;

implementation
uses GestionTextes;
{$R *.dfm}

procedure TFdemMotCle.IncludeBtnClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := GetFirstSelection(SrcList);
  MoveSelected(SrcList, DstList.Items);
  SetItem(SrcList, Index);
end;

procedure TFdemMotCle.ExcludeBtnClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := GetFirstSelection(DstList);
  MoveSelected(DstList, SrcList.Items);
  SetItem(DstList, Index);
end;

procedure TFdemMotCle.IncAllBtnClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to SrcList.Items.Count - 1 do
    DstList.Items.AddObject(SrcList.Items[I], 
      SrcList.Items.Objects[I]);
  SrcList.Items.Clear;
  SetItem(SrcList, 0);
end;

procedure TFdemMotCle.ExcAllBtnClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to DstList.Items.Count - 1 do
    SrcList.Items.AddObject(DstList.Items[I], DstList.Items.Objects[I]);
  DstList.Items.Clear;
  SetItem(DstList, 0);
end;

procedure TFdemMotCle.MoveSelected(List: TCustomListBox; Items: TStrings);
var
  I: Integer;
begin
  for I := List.Items.Count - 1 downto 0 do
    if List.Selected[I] then
    begin
      Items.AddObject(List.Items[I], List.Items.Objects[I]);
      List.Items.Delete(I);
    end;
end;

procedure TFdemMotCle.SetButtons;
var
  SrcEmpty, DstEmpty: Boolean;
begin
  SrcEmpty := SrcList.Items.Count = 0;
  DstEmpty := DstList.Items.Count = 0;
  IncludeBtn.Enabled := not SrcEmpty;
  IncAllBtn.Enabled := not SrcEmpty;
  ExcludeBtn.Enabled := not DstEmpty;
  ExAllBtn.Enabled := not DstEmpty;
end;

function TFdemMotCle.GetFirstSelection(List: TCustomListBox): Integer;
begin
  for Result := 0 to List.Items.Count - 1 do
    if List.Selected[Result] then Exit;
  Result := LB_ERR;
end;

procedure TFdemMotCle.SetItem(List: TListBox; Index: Integer);
var
  MaxIndex: Integer;
begin
  with List do
  begin
    SetFocus;
    MaxIndex := List.Items.Count - 1;
    if Index = LB_ERR then Index := 0
    else if Index > MaxIndex then Index := MaxIndex;
    Selected[Index] := True;
  end;
  SetButtons;
end;

procedure TFdemMotCle.FormCreate(Sender: TObject);
begin
  LesGroupes:=TStringList.Create;
  LesSequences:=TStringList.Create;
  ActiveControl:=ListeMots;
  Caption:=C_FdemMotCle; // Gestion des mots-cls
  Label1.Caption:=C_FdemMotCleLabel1; // crire le nouveau mot-cl ou choisir son nom dans la liste
  Button1.Caption:=C_FdemMotCleButton1; // Ajouter
  Button3.Caption:=C_FdemMotCleButton3; // Supprimer
  Label4.Caption:=C_FdemMotCleLabel41+Chr(13)+Chr(10)+C_FdemMotCleLabel4; // finale
  BitBtn1.Caption:=C_FormPrincOKgroupe; // OK
  SrcLabel.Caption:=C_FdemMotCleSrcLabel; // Squences disponibles :
  DstLabel.Caption:=C_FdemMotCleDstLabel; // Squences associes au mot-cl :
  Label3.Caption:=C_FdemMotCleLabel3; // Choix des squences associes au mot-cl
  Button2.Caption:=C_FormPrincOKgroupe; // OK  
end;

procedure TFdemMotCle.FormDestroy(Sender: TObject);
begin
  LesGroupes.Free;
  LesSequences.Free;
end;

procedure TFdemMotCle.ListeMotsKeyPress(Sender: TObject; var Key: Char);
begin
  ListeMots.SetFocus;
  if Key=Chr(13) then
    Button1Click(Sender);
end;

procedure TFdemMotCle.Button1Click(Sender: TObject);
var
  n:integer;
begin
  n:=ListeMots.Items.IndexOf(ListeMots.Text);
  if n>-1 then
    begin
      ListeMots.ItemIndex:=n;
      AjusteListe(n);
    end
  else if ListeMots.Text<>'' then
    begin
      ListeMots.Items.Add(ListeMots.Text);
      DstList.Clear;
      SrcList.Clear;
      SrcList.Items.AddStrings(LesSequences);
    end;
end;

procedure TFdemMotCle.ListeMotsChange(Sender: TObject);
Var
  n:integer;
begin
  ActiveControl:=ListeMots;
  n:=ListeMots.ItemIndex;        
  if n>-1 then
    begin
      AjusteListe(n);
      Button1.Visible:=False;
    end
  else
      Button1.Visible:=True;
end;
procedure TFdemMotCle.AjusteListe(i:integer);
Var
  j:integer;
  LGi:TStringList;
begin
  if (i=-1)or (i>=LesGroupes.Count) then
    begin
      SrcList.Clear;
      DstList.Clear;
      SrcList.Items.AddStrings(LesSequences);
    end
  else
    begin
      LGi:=TStringList.Create;
      try
        LGi.CommaText:=LesGroupes[i];
        SrcList.Clear;
        DstList.Clear;
        for j:=0 to LesSequences.Count-1 do
          begin
            if LGi.IndexOf(LesSequences[j])>-1 then
              DstList.Items.Add(LesSequences[j])
            else
              SrcList.Items.Add(LesSequences[j]);
          end;
      finally
        LGi.Free;
      end;
    end;
end;
procedure TFdemMotCle.ListeMotsDropDown(Sender: TObject);
begin
  if ListeMots.ItemIndex>-1 then
  AjusteListe(ListeMots.ItemIndex);
end;

procedure TFdemMotCle.Button2Click(Sender: TObject);
var
  i,j:integer;
  LGi:TStringList;
begin
  if trim(ListeMots.Text)='' then exit;
  LGi:=TStringList.Create;
  try
    LGi.AddStrings(DstList.Items);
    i:=ListeMots.Items.IndexOf(ListeMots.Text);
    if (i=-1) then
      begin
        ListeMots.Items.Add(ListeMots.Text);
      end;
    i:=ListeMots.Items.IndexOf(ListeMots.Text);
    if i>-1 then
      begin
        for j:= LesGroupes.Count to i do
          LesGroupes.Add('');
        LesGroupes[i]:=LGi.CommaText;
      end;
  finally
    LGi.Free;
  end;
end;

procedure TFdemMotCle.Button3Click(Sender: TObject);
var
  n:integer;
begin
  n:=ListeMots.Items.IndexOf(ListeMots.Text);
  if n>-1 then
    begin
      if MessageDlg('Voulez-vous supprimer ce mot-cl ?',mtConfirmation,[mbYes,mbNo],0)=mrYes then
        begin
          ListeMots.Items.Delete(n);
          if n<LesGroupes.Count then
          LesGroupes.Delete(n);
          AjusteListe(ListeMots.ItemIndex);
        end;
    end
  else
    begin
      ListeMots.Text:='';
      AjusteListe(-1);
    end;
end;

end.
